//[LISTING TWO]
//may91b.c
/* Draws a non-antialiased line from (X1,Y1) to (X2,Y2) into the buffer 
pointed to by BufferPtr, of width BufferWidth and height BufferHeight. */

#include <dos.h>
#include <math.h>
#define SWAP(a,b) {temp = a; a = b; b = temp;}

void DrawLine(unsigned char *BufferPtr, int BufferWidth,
      int BufferHeight, int X1, int Y1, int X2, int Y2, int color)
{
   int X, Y, DeltaX, DeltaY, temp;
   double Slope, InverseSlope;

   /* Calculate the X and Y lengths of the line */
   DeltaX = X2 - X1;
   DeltaY = Y2 - Y1;

   /* Determine the major axis */
   if (abs(DeltaY) > abs(DeltaX)) {
      /* Y is the major axis */
      if (DeltaY < 0) {    /* make sure DeltaY is positive */
         SWAP(X1, X2);
         SWAP(Y1, Y2);
         DeltaX = -DeltaX;
         DeltaY = -DeltaY;
      }
      InverseSlope = (double)DeltaX / (double)DeltaY;
      /* Scan out the line, stepping along the Y axis one pixel at a
         time and calculating the corresponding X coordinates */
      for (Y = Y1; Y <= Y2; Y++) {
         X = X1 + (int)floor(((double)(Y - Y1) * InverseSlope) + 0.5);
         *(BufferPtr + BufferWidth * Y + X) = color;
      }
   } else {
      /* X is the major axis */
      if (DeltaX < 0) {    /* make sure DeltaX is positive */
         SWAP(X1, X2);
         SWAP(Y1, Y2);
         DeltaX = -DeltaX;
         DeltaY = -DeltaY;
      }
      Slope = (double)DeltaY / (double)DeltaX;
      /* Scan out the line, stepping along the X axis one pixel at a
         time and calculating the corresponding Y coordinates */
      for (X = X1; X <= X2; X++) {
         Y = Y1 + (int)floor(((double)(X - X1) * Slope) + 0.5);
         *(BufferPtr + BufferWidth * Y + X) = color;
      }
   }
}


